# Overview

In this section, we present some applications of ADCME to physics based machine learning. 
We design data-driven algorithms for estimating unknown parameters, functions, functionals, and stochastic processes to physical or statistical models. One highlight of the applications is using neural networks to approximate the unknowns, and at the same time preserving the physical constraints such as conservation laws. We believe that as deep learning technology continues to grow, building an AD tool based on the deep learning framework will benefit scientific computing and helps solve long standing challenging inverse problems. Meanwhile, we can leverage the knowledge of physical laws to reduce the amount of data required for training deep neural networks.
 This goal is achieved by the insights into the connection between deep learning algorithms and inverse modeling algorithm via automatic differentiation.


**Sample Applications**

[Adversarial Numerical Analysis](./apps_ana.md)

[Intelligent Automatic Differentiation ](./apps_ad.md)

[Learning Constitutive Relations from Indirect Observations Using Deep Neural Networks](./apps_constitutive_law.md)

[Calibrating Multivariate Lévy Processes with Neural Networks](./apps_levy.md)

[General Seismic Inversion using Automatic Differentiation](./apps_adseismic.md)

[Symmetric Positive Definite Neural Networks (SPD-NN)](./apps_nnfem.md)